/* -*- Mode: C++; c-basic-offset:4 ; -*- */
/*  
 *  (C) 2001 by Argonne National Laboratory.
 *      See COPYRIGHT in top-level directory.
 *
 * This file is automatically generated by buildiface -nosep -noromio
 * DO NOT EDIT
 */
/* style: c++ header */

namespace MPI {
#ifdef HAVE_CXX_EXCEPTIONS
#define MPIX_CALL( fnc ) \
{int err; err = fnc ; if (err) throw Exception(err);}
#else
#define MPIX_CALL( fnc ) (void)fnc
#endif

// Typedefs for basic int types
typedef long MPI::Offset;
typedef long MPI::Aint;
typedef int MPI::Fint;
class Datatype  {
    friend class Comm;
    friend class Status;
    friend class Intracomm;
    friend class Intercomm;
		
  protected:
    MPI_Datatype the_real_datatype;

  public:
    // new/delete
    inline Datatype(MPI_Datatype obj) { the_real_datatype = obj; }
    inline Datatype(void) {the_real_datatype = MPI_DATATYPE_NULL;}

    virtual ~Datatype() {}
    // copy/assignment
    Datatype :: Datatype(const Datatype &obj) {
      the_real_datatype = obj.the_real_datatype; }
    Datatype& Datatype::operator=(const Datatype &obj) {
      the_real_datatype = obj.the_real_datatype; return *this; }
    // logical
    bool operator== (const Datatype &obj) {
      return (the_real_datatype == obj.the_real_datatype); }
    bool operator!= (const Datatype &obj) {
      return (the_real_datatype != obj.the_real_datatype); }
    // C/C++ cast and assignment
    inline operator MPI_Datatype*() { return &the_real_datatype; }
    inline operator MPI_Datatype() { return the_real_datatype; }
    Datatype& Datatype::operator=(const MPI_Datatype& obj) {
      the_real_datatype = obj; return *this; }
    void Commit( void )
    {
        MPIX_CALL( MPI_Type_commit( (MPI_Datatype *) &the_real_datatype ));
    }
    Datatype Create_contiguous( int v1 )
    {
        Datatype *v3 = new Datatype;
        MPIX_CALL( MPI_Type_contiguous( v1, (MPI_Datatype) the_real_datatype, &(v3->the_real_datatype) ));
        return *v3;
    }
    Datatype Create_vector( int v1, int v2, int v3 )
    {
        Datatype *v5 = new Datatype;
        MPIX_CALL( MPI_Type_vector( v1, v2, v3, (MPI_Datatype) the_real_datatype, &(v5->the_real_datatype) ));
        return *v5;
    }
    Datatype Create_indexed( int v1, int * v2, int * v3 )
    {
        Datatype *v5 = new Datatype;
        MPIX_CALL( MPI_Type_indexed( v1, v2, v3, (MPI_Datatype) the_real_datatype, &(v5->the_real_datatype) ));
        return *v5;
    }
    int Pack_size( int v1, Comm v3 )
;
    int Get_size( void )
    {
        int v2;
        MPIX_CALL( MPI_Type_size( (MPI_Datatype) the_real_datatype, &v2 ));
        return v2;
    }
    void Free( void )
    {
        MPIX_CALL( MPI_Type_free( (MPI_Datatype *) &the_real_datatype ));
    }
    void Unpack( void* v1, int v2, int * v3, void * v4, int v5, Comm v7 )
;
    void Pack( void* v1, int v2, void * v4, int v5, int * v6, Comm v7 )
;
    void Get_name( char * v2, int * v3 )
    {
        MPIX_CALL( MPI_Type_get_name( (MPI_Datatype) the_real_datatype, v2, v3 ));
    }
    void Set_name( char * v2 )
    {
        MPIX_CALL( MPI_Type_set_name( (MPI_Datatype) the_real_datatype, v2 ));
    }
};
class Info  {
		
  protected:
    MPI_Info the_real_info;

  public:
    // new/delete
    inline Info(MPI_Info obj) { the_real_info = obj; }
    inline Info(void) {the_real_info = MPI_INFO_NULL;}

    virtual ~Info() {}
    // copy/assignment
    Info :: Info(const Info &obj) {
      the_real_info = obj.the_real_info; }
    Info& Info::operator=(const Info &obj) {
      the_real_info = obj.the_real_info; return *this; }
    // logical
    bool operator== (const Info &obj) {
      return (the_real_info == obj.the_real_info); }
    bool operator!= (const Info &obj) {
      return (the_real_info != obj.the_real_info); }
    // C/C++ cast and assignment
    inline operator MPI_Info*() { return &the_real_info; }
    inline operator MPI_Info() { return the_real_info; }
    Info& Info::operator=(const MPI_Info& obj) {
      the_real_info = obj; return *this; }
};
class Status  {
    friend class Comm;
    friend class File;
    friend class Request;
		
  protected:
    MPI_Status the_real_status;

  public:
    // new/delete
    inline Status(MPI_Status obj) { the_real_status = obj; }
    inline Status(void) {}

    virtual ~Status() {}
    // copy/assignment
    Status :: Status(const Status &obj) {
      the_real_status = obj.the_real_status; }
    Status& Status::operator=(const Status &obj) {
      the_real_status = obj.the_real_status; return *this; }
    // C/C++ cast and assignment
    inline operator MPI_Status*() { return &the_real_status; }
    inline operator MPI_Status() { return the_real_status; }
    Status& Status::operator=(const MPI_Status& obj) {
      the_real_status = obj; return *this; }
    int Is_cancelled( void )
    {
        int v2;
        MPIX_CALL( MPI_Test_cancelled( (MPI_Status *) &the_real_status, &v2 ));
        return v2;
    }
    int Get_elements( Datatype v2 )
    {
        int v3;
        MPIX_CALL( MPI_Get_elements( (MPI_Status *) &the_real_status, (MPI_Datatype)(v2.the_real_datatype), &v3 ));
        return v3;
    }
    int Get_count( Datatype v2 )
    {
        int v3;
        MPIX_CALL( MPI_Get_count( (MPI_Status *) &the_real_status, (MPI_Datatype)(v2.the_real_datatype), &v3 ));
        return v3;
    }
};
class Group  {
    friend class Comm;
    friend class Intracomm;
    friend class Intercomm;
		
  protected:
    MPI_Group the_real_group;

  public:
    // new/delete
    inline Group(MPI_Group obj) { the_real_group = obj; }
    inline Group(void) {the_real_group = MPI_GROUP_NULL;}

    virtual ~Group() {}
    // copy/assignment
    Group :: Group(const Group &obj) {
      the_real_group = obj.the_real_group; }
    Group& Group::operator=(const Group &obj) {
      the_real_group = obj.the_real_group; return *this; }
    // logical
    bool operator== (const Group &obj) {
      return (the_real_group == obj.the_real_group); }
    bool operator!= (const Group &obj) {
      return (the_real_group != obj.the_real_group); }
    // C/C++ cast and assignment
    inline operator MPI_Group*() { return &the_real_group; }
    inline operator MPI_Group() { return the_real_group; }
    Group& Group::operator=(const MPI_Group& obj) {
      the_real_group = obj; return *this; }
    int Compare( Group v2 )
    {
        int v3;
        MPIX_CALL( MPI_Group_compare( (MPI_Group) the_real_group, (MPI_Group)(v2.the_real_group), &v3 ));
        return v3;
    }
    Group Difference( Group v2 )
    {
        Group *v3 = new Group;
        MPIX_CALL( MPI_Group_difference( (MPI_Group) the_real_group, (MPI_Group)(v2.the_real_group), &(v3->the_real_group) ));
        return *v3;
    }
    Group Intersect( Group v2 )
    {
        Group *v3 = new Group;
        MPIX_CALL( MPI_Group_intersection( (MPI_Group) the_real_group, (MPI_Group)(v2.the_real_group), &(v3->the_real_group) ));
        return *v3;
    }
    int Get_size( void )
    {
        int v2;
        MPIX_CALL( MPI_Group_size( (MPI_Group) the_real_group, &v2 ));
        return v2;
    }
    Group Union( Group v2 )
    {
        Group *v3 = new Group;
        MPIX_CALL( MPI_Group_union( (MPI_Group) the_real_group, (MPI_Group)(v2.the_real_group), &(v3->the_real_group) ));
        return *v3;
    }
    void Free( void )
    {
        MPIX_CALL( MPI_Group_free( (MPI_Group *) &the_real_group ));
    }
    int Get_rank( void )
    {
        int v2;
        MPIX_CALL( MPI_Group_rank( (MPI_Group) the_real_group, &v2 ));
        return v2;
    }
    Group Excl( int v2, int * v3 )
    {
        Group *v4 = new Group;
        MPIX_CALL( MPI_Group_excl( (MPI_Group) the_real_group, v2, v3, &(v4->the_real_group) ));
        return *v4;
    }
    Group Incl( int v2, int * v3 )
    {
        Group *v4 = new Group;
        MPIX_CALL( MPI_Group_incl( (MPI_Group) the_real_group, v2, v3, &(v4->the_real_group) ));
        return *v4;
    }
    void Translate_ranks( int v2, int * v3, Group v4, int * v5 )
    {
        MPIX_CALL( MPI_Group_translate_ranks( (MPI_Group) the_real_group, v2, v3, (MPI_Group)(v4.the_real_group), v5 ));
    }
};
class Op  {
    friend class Intracomm;
		
  protected:
    MPI_Op the_real_op;

  public:
    // new/delete
    inline Op(MPI_Op obj) { the_real_op = obj; }
    inline Op(void) {the_real_op = MPI_OP_NULL;}

    virtual ~Op() {}
    // copy/assignment
    Op :: Op(const Op &obj) {
      the_real_op = obj.the_real_op; }
    Op& Op::operator=(const Op &obj) {
      the_real_op = obj.the_real_op; return *this; }
    // logical
    bool operator== (const Op &obj) {
      return (the_real_op == obj.the_real_op); }
    bool operator!= (const Op &obj) {
      return (the_real_op != obj.the_real_op); }
    // C/C++ cast and assignment
    inline operator MPI_Op*() { return &the_real_op; }
    inline operator MPI_Op() { return the_real_op; }
    Op& Op::operator=(const MPI_Op& obj) {
      the_real_op = obj; return *this; }
    void Free( void )
    {
        MPIX_CALL( MPI_Op_free( (MPI_Op *) &the_real_op ));
    }
};
class Errhandler  {
		
  protected:
    MPI_Errhandler the_real_errhandler;

  public:
    // new/delete
    inline Errhandler(MPI_Errhandler obj) { the_real_errhandler = obj; }
    inline Errhandler(void) {the_real_errhandler = MPI_ERRHANDLER_NULL;}

    virtual ~Errhandler() {}
    // copy/assignment
    Errhandler :: Errhandler(const Errhandler &obj) {
      the_real_errhandler = obj.the_real_errhandler; }
    Errhandler& Errhandler::operator=(const Errhandler &obj) {
      the_real_errhandler = obj.the_real_errhandler; return *this; }
    // logical
    bool operator== (const Errhandler &obj) {
      return (the_real_errhandler == obj.the_real_errhandler); }
    bool operator!= (const Errhandler &obj) {
      return (the_real_errhandler != obj.the_real_errhandler); }
    // C/C++ cast and assignment
    inline operator MPI_Errhandler*() { return &the_real_errhandler; }
    inline operator MPI_Errhandler() { return the_real_errhandler; }
    Errhandler& Errhandler::operator=(const MPI_Errhandler& obj) {
      the_real_errhandler = obj; return *this; }
    void Free( void )
    {
        MPIX_CALL( MPI_Errhandler_free( (MPI_Errhandler *) &the_real_errhandler ));
    }
};
class Request  {
    friend class Comm;
		
  protected:
    MPI_Request the_real_request;

  public:
    // new/delete
    inline Request(MPI_Request obj) { the_real_request = obj; }
    inline Request(void) {the_real_request = MPI_REQUEST_NULL;}

    virtual ~Request() {}
    // copy/assignment
    Request :: Request(const Request &obj) {
      the_real_request = obj.the_real_request; }
    Request& Request::operator=(const Request &obj) {
      the_real_request = obj.the_real_request; return *this; }
    // logical
    bool operator== (const Request &obj) {
      return (the_real_request == obj.the_real_request); }
    bool operator!= (const Request &obj) {
      return (the_real_request != obj.the_real_request); }
    // C/C++ cast and assignment
    inline operator MPI_Request*() { return &the_real_request; }
    inline operator MPI_Request() { return the_real_request; }
    Request& Request::operator=(const MPI_Request& obj) {
      the_real_request = obj; return *this; }
    void Cancel( void )
    {
        MPIX_CALL( MPI_Cancel( (MPI_Request *) &the_real_request ));
    }
    void Free( void )
    {
        MPIX_CALL( MPI_Request_free( (MPI_Request *) &the_real_request ));
    }
    void Wait( Status & v2 )
    {
        MPIX_CALL( MPI_Wait( (MPI_Request *) &the_real_request, (MPI_Status *)&(v2.the_real_status ) ));
    }
    int Test( Status & v3 )
    {
        int v2;
        MPIX_CALL( MPI_Test( (MPI_Request *) &the_real_request, &v2, (MPI_Status *)&(v3.the_real_status ) ));
        return v2;
    }
};
class Prequest : public Request {
		
  protected:
    MPI_Request the_real_prequest;

  public:
    // new/delete
    inline Prequest(MPI_Request obj) { the_real_prequest = obj; }
    inline Prequest(void) {the_real_prequest = MPI_REQUEST_NULL;}

    virtual ~Prequest() {}
    // copy/assignment
    Prequest :: Prequest(const Prequest &obj) {
      the_real_prequest = obj.the_real_prequest; }
    Prequest& Prequest::operator=(const Prequest &obj) {
      the_real_prequest = obj.the_real_prequest; return *this; }
    // logical
    bool operator== (const Prequest &obj) {
      return (the_real_prequest == obj.the_real_prequest); }
    bool operator!= (const Prequest &obj) {
      return (the_real_prequest != obj.the_real_prequest); }
    // C/C++ cast and assignment
    inline operator MPI_Request*() { return &the_real_prequest; }
    inline operator MPI_Request() { return the_real_prequest; }
    Prequest& Prequest::operator=(const MPI_Request& obj) {
      the_real_prequest = obj; return *this; }
};
class Comm  {
    friend class Cartcomm;
    friend class Intercomm;
    friend class Intracomm;
    friend class Graphcomm;
    friend class Datatype;
		
  protected:
    MPI_Comm the_real_comm;

  public:
    // new/delete
    inline Comm(MPI_Comm obj) { the_real_comm = obj; }
    inline Comm(void) {the_real_comm = MPI_COMM_NULL;}

    virtual ~Comm() {}
    // copy/assignment
    Comm :: Comm(const Comm &obj) {
      the_real_comm = obj.the_real_comm; }
    Comm& Comm::operator=(const Comm &obj) {
      the_real_comm = obj.the_real_comm; return *this; }
    // logical
    bool operator== (const Comm &obj) {
      return (the_real_comm == obj.the_real_comm); }
    bool operator!= (const Comm &obj) {
      return (the_real_comm != obj.the_real_comm); }
    // C/C++ cast and assignment
    inline operator MPI_Comm*() { return &the_real_comm; }
    inline operator MPI_Comm() { return the_real_comm; }
    Comm& Comm::operator=(const MPI_Comm& obj) {
      the_real_comm = obj; return *this; }
    void Sendrecv_repl( void* v1, int v2, Datatype v3, int v4, int v5, int v6, int v7, Status & v9 )
    {
        MPIX_CALL( MPI_Sendrecv_replace( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, v7, (MPI_Comm) the_real_comm, (MPI_Status *)&(v9.the_real_status ) ));
    }
    void Abort( int v2 )
    {
        MPIX_CALL( MPI_Abort( (MPI_Comm) the_real_comm, v2 ));
    }
    Request Issend( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Issend( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    void Rsend( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        MPIX_CALL( MPI_Rsend( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm ));
    }
    int Get_size( void )
    {
        int v2;
        MPIX_CALL( MPI_Comm_size( (MPI_Comm) the_real_comm, &v2 ));
        return v2;
    }
    void Send( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        MPIX_CALL( MPI_Send( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm ));
    }
    int Get_topology( void )
    {
        int v2;
        MPIX_CALL( MPI_Topo_test( (MPI_Comm) the_real_comm, &v2 ));
        return v2;
    }
    void Free( void )
    {
        MPIX_CALL( MPI_Comm_free( (MPI_Comm *) &the_real_comm ));
    }
    void Ssend( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        MPIX_CALL( MPI_Ssend( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm ));
    }
    Request Ibsend( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Ibsend( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    void Sendrecv( void * v1, int v2, Datatype v3, int v4, int v5, void * v6, int v7, Datatype v8, int v9, int v10, Status & v12 )
    {
        MPIX_CALL( MPI_Sendrecv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, v7, (MPI_Datatype)(v8.the_real_datatype), v9, v10, (MPI_Comm) the_real_comm, (MPI_Status *)&(v12.the_real_status ) ));
    }
    Request Recv_init( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Recv_init( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    Request Bsend_init( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Bsend_init( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    Request Rsend_init( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Rsend_init( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    int Compare( Comm v2 )
    {
        int v3;
        MPIX_CALL( MPI_Comm_compare( (MPI_Comm) the_real_comm, (MPI_Comm)(v2.the_real_comm), &v3 ));
        return v3;
    }
    void Bsend( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        MPIX_CALL( MPI_Bsend( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm ));
    }
    Request Isend( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Isend( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    int Iprobe( int v1, int v2, Status & v5 )
    {
        int v4;
        MPIX_CALL( MPI_Iprobe( v1, v2, (MPI_Comm) the_real_comm, &v4, (MPI_Status *)&(v5.the_real_status ) ));
        return v4;
    }
    Request Send_init( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Send_init( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    int Get_rank( void )
    {
        int v2;
        MPIX_CALL( MPI_Comm_rank( (MPI_Comm) the_real_comm, &v2 ));
        return v2;
    }
    Group Get_group( void )
    {
        Group *v2 = new Group;
        MPIX_CALL( MPI_Comm_group( (MPI_Comm) the_real_comm, &(v2->the_real_group) ));
        return *v2;
    }
    void Probe( int v1, int v2, Status & v4 )
    {
        MPIX_CALL( MPI_Probe( v1, v2, (MPI_Comm) the_real_comm, (MPI_Status *)&(v4.the_real_status ) ));
    }
    Request Irsend( void* v1, int v2, Datatype v3, int v4, int v5 )
    {
        Request *v7 = new Request;
        MPIX_CALL( MPI_Irsend( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, &(v7->the_real_request) ));
        return *v7;
    }
    void Recv( void* v1, int v2, Datatype v3, int v4, int v5, Status & v7 )
    {
        MPIX_CALL( MPI_Recv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Comm) the_real_comm, (MPI_Status *)&(v7.the_real_status ) ));
    }
};
class Intercomm : public Comm {
    friend class Intracomm;

  public:
    // new/delete
    inline Intercomm(MPI_Comm obj) { the_real_comm = obj; }
    inline Intercomm(void) {the_real_comm = MPI_COMM_NULL;}

    virtual ~Intercomm() {}
    // copy/assignment
    Intercomm :: Intercomm(const Intercomm &obj) {
      the_real_comm = obj.the_real_comm; }
    Intercomm& Intercomm::operator=(const Intercomm &obj) {
      the_real_comm = obj.the_real_comm; return *this; }
    // logical
    bool operator== (const Intercomm &obj) {
      return (the_real_comm == obj.the_real_comm); }
    bool operator!= (const Intercomm &obj) {
      return (the_real_comm != obj.the_real_comm); }
    // C/C++ cast and assignment
    inline operator MPI_Comm*() { return &the_real_comm; }
    inline operator MPI_Comm() { return the_real_comm; }
    Intercomm& Intercomm::operator=(const MPI_Comm& obj) {
      the_real_comm = obj; return *this; }
    Group Get_remote_group( void )
    {
        Group *v2 = new Group;
        MPIX_CALL( MPI_Comm_remote_group( (MPI_Comm) the_real_comm, &(v2->the_real_group) ));
        return *v2;
    }
    int Get_remote_size( void )
    {
        int v2;
        MPIX_CALL( MPI_Comm_remote_size( (MPI_Comm) the_real_comm, &v2 ));
        return v2;
    }
    Comm Merge( int v2 )
    {
        Comm *v3 = new Comm;
        MPIX_CALL( MPI_Intercomm_merge( (MPI_Comm) the_real_comm, v2, &(v3->the_real_comm) ));
        return *v3;
    }
    Comm Dup( void )
    {
        Comm *v2 = new Comm;
        MPIX_CALL( MPI_Comm_dup( (MPI_Comm) the_real_comm, &(v2->the_real_comm) ));
        return *v2;
    }
};
class Intracomm : public Comm {
    friend class Cartcomm;
    friend class Graphcomm;
    friend class Datatype;

  public:
    // new/delete
    inline Intracomm(MPI_Comm obj) { the_real_comm = obj; }
    inline Intracomm(void) {the_real_comm = MPI_COMM_NULL;}

    virtual ~Intracomm() {}
    // copy/assignment
    Intracomm :: Intracomm(const Intracomm &obj) {
      the_real_comm = obj.the_real_comm; }
    Intracomm& Intracomm::operator=(const Intracomm &obj) {
      the_real_comm = obj.the_real_comm; return *this; }
    // logical
    bool operator== (const Intracomm &obj) {
      return (the_real_comm == obj.the_real_comm); }
    bool operator!= (const Intracomm &obj) {
      return (the_real_comm != obj.the_real_comm); }
    // C/C++ cast and assignment
    inline operator MPI_Comm*() { return &the_real_comm; }
    inline operator MPI_Comm() { return the_real_comm; }
    Intracomm& Intracomm::operator=(const MPI_Comm& obj) {
      the_real_comm = obj; return *this; }
    Comm Create( Group v2 )
    {
        Comm *v3 = new Comm;
        MPIX_CALL( MPI_Comm_create( (MPI_Comm) the_real_comm, (MPI_Group)(v2.the_real_group), &(v3->the_real_comm) ));
        return *v3;
    }
    void Bcast( void* v1, int v2, Datatype v3, int v4 )
    {
        MPIX_CALL( MPI_Bcast( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, (MPI_Comm) the_real_comm ));
    }
    void Barrier( void )
    {
        MPIX_CALL( MPI_Barrier( (MPI_Comm) the_real_comm ));
    }
    void Alltoall( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6 )
    {
        MPIX_CALL( MPI_Alltoall( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    void Gather( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6, int v7 )
    {
        MPIX_CALL( MPI_Gather( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), v7, (MPI_Comm) the_real_comm ));
    }
    Comm Create_intercomm( int v2, Comm v3, int v4, int v5 )
    {
        Comm *v6 = new Comm;
        MPIX_CALL( MPI_Intercomm_create( (MPI_Comm) the_real_comm, v2, (MPI_Comm)(v3.the_real_comm), v4, v5, &(v6->the_real_comm) ));
        return *v6;
    }
    void Reduce_scatter( void* v1, void* v2, int * v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Reduce_scatter( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
    void Scatterv( void* v1, int * v2, int * v3, Datatype v4, void* v5, int v6, Datatype v7, int v8 )
    {
        MPIX_CALL( MPI_Scatterv( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), v5, v6, (MPI_Datatype)(v7.the_real_datatype), v8, (MPI_Comm) the_real_comm ));
    }
    void Allgather( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6 )
    {
        MPIX_CALL( MPI_Allgather( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    Comm Dup( void )
    {
        Comm *v2 = new Comm;
        MPIX_CALL( MPI_Comm_dup( (MPI_Comm) the_real_comm, &(v2->the_real_comm) ));
        return *v2;
    }
    void Reduce( void* v1, void* v2, int v3, Datatype v4, Op v5, int v6 )
    {
        MPIX_CALL( MPI_Reduce( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), v6, (MPI_Comm) the_real_comm ));
    }
    void Scan( void* v1, void* v2, int v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Scan( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
    void Alltoallv( void* v1, int * v2, int * v3, Datatype v4, void* v5, int * v6, int * v7, Datatype v8 )
    {
        MPIX_CALL( MPI_Alltoallv( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), v5, v6, v7, (MPI_Datatype)(v8.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    Comm Create_cart( int v2, int * v3, int * v4, int v5 )
    {
        Comm *v6 = new Comm;
        MPIX_CALL( MPI_Cart_create( (MPI_Comm) the_real_comm, v2, v3, v4, v5, &(v6->the_real_comm) ));
        return *v6;
    }
    void Allreduce( void* v1, void* v2, int v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Allreduce( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
    Comm Split( int v2, int v3 )
    {
        Comm *v4 = new Comm;
        MPIX_CALL( MPI_Comm_split( (MPI_Comm) the_real_comm, v2, v3, &(v4->the_real_comm) ));
        return *v4;
    }
    void Allgatherv( void* v1, int v2, Datatype v3, void* v4, int * v5, int * v6, Datatype v7 )
    {
        MPIX_CALL( MPI_Allgatherv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, (MPI_Datatype)(v7.the_real_datatype), (MPI_Comm) the_real_comm ));
    }
    void Scatter( void* v1, int v2, Datatype v3, void* v4, int v5, Datatype v6, int v7 )
    {
        MPIX_CALL( MPI_Scatter( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, (MPI_Datatype)(v6.the_real_datatype), v7, (MPI_Comm) the_real_comm ));
    }
    void Gatherv( void* v1, int v2, Datatype v3, void* v4, int * v5, int * v6, Datatype v7, int v8 )
    {
        MPIX_CALL( MPI_Gatherv( v1, v2, (MPI_Datatype)(v3.the_real_datatype), v4, v5, v6, (MPI_Datatype)(v7.the_real_datatype), v8, (MPI_Comm) the_real_comm ));
    }
    Comm Create_graph( int v2, int * v3, int * v4, int v5 )
    {
        Comm *v6 = new Comm;
        MPIX_CALL( MPI_Graph_create( (MPI_Comm) the_real_comm, v2, v3, v4, v5, &(v6->the_real_comm) ));
        return *v6;
    }
    void Exscan( void * v1, void * v2, int v3, Datatype v4, Op v5 )
    {
        MPIX_CALL( MPI_Exscan( v1, v2, v3, (MPI_Datatype)(v4.the_real_datatype), (MPI_Op)(v5.the_real_op), (MPI_Comm) the_real_comm ));
    }
};
class Grequest : public Request {
		
  protected:
    MPI_Request the_real_grequest;

  public:
    // new/delete
    inline Grequest(MPI_Request obj) { the_real_grequest = obj; }
    inline Grequest(void) {the_real_grequest = MPI_REQUEST_NULL;}

    virtual ~Grequest() {}
    // copy/assignment
    Grequest :: Grequest(const Grequest &obj) {
      the_real_grequest = obj.the_real_grequest; }
    Grequest& Grequest::operator=(const Grequest &obj) {
      the_real_grequest = obj.the_real_grequest; return *this; }
    // logical
    bool operator== (const Grequest &obj) {
      return (the_real_grequest == obj.the_real_grequest); }
    bool operator!= (const Grequest &obj) {
      return (the_real_grequest != obj.the_real_grequest); }
    // C/C++ cast and assignment
    inline operator MPI_Request*() { return &the_real_grequest; }
    inline operator MPI_Request() { return the_real_grequest; }
    Grequest& Grequest::operator=(const MPI_Request& obj) {
      the_real_grequest = obj; return *this; }
};
class Win  {
    friend class Datatype;
		
  protected:
    MPI_Win the_real_win;

  public:
    // new/delete
    inline Win(MPI_Win obj) { the_real_win = obj; }
    inline Win(void) {the_real_win = MPI_WIN_NULL;}

    virtual ~Win() {}
    // copy/assignment
    Win :: Win(const Win &obj) {
      the_real_win = obj.the_real_win; }
    Win& Win::operator=(const Win &obj) {
      the_real_win = obj.the_real_win; return *this; }
    // logical
    bool operator== (const Win &obj) {
      return (the_real_win == obj.the_real_win); }
    bool operator!= (const Win &obj) {
      return (the_real_win != obj.the_real_win); }
    // C/C++ cast and assignment
    inline operator MPI_Win*() { return &the_real_win; }
    inline operator MPI_Win() { return the_real_win; }
    Win& Win::operator=(const MPI_Win& obj) {
      the_real_win = obj; return *this; }
};
class Graphcomm : public Intracomm {
		
  protected:
    MPI_Comm the_real_graphcomm;

  public:
    // new/delete
    inline Graphcomm(MPI_Comm obj) { the_real_graphcomm = obj; }
    inline Graphcomm(void) {the_real_graphcomm = MPI_COMM_NULL;}

    virtual ~Graphcomm() {}
    // copy/assignment
    Graphcomm :: Graphcomm(const Graphcomm &obj) {
      the_real_graphcomm = obj.the_real_graphcomm; }
    Graphcomm& Graphcomm::operator=(const Graphcomm &obj) {
      the_real_graphcomm = obj.the_real_graphcomm; return *this; }
    // logical
    bool operator== (const Graphcomm &obj) {
      return (the_real_graphcomm == obj.the_real_graphcomm); }
    bool operator!= (const Graphcomm &obj) {
      return (the_real_graphcomm != obj.the_real_graphcomm); }
    // C/C++ cast and assignment
    inline operator MPI_Comm*() { return &the_real_graphcomm; }
    inline operator MPI_Comm() { return the_real_graphcomm; }
    Graphcomm& Graphcomm::operator=(const MPI_Comm& obj) {
      the_real_graphcomm = obj; return *this; }
    void Map( int v2, int * v3, int * v4, int * v5 )
    {
        MPIX_CALL( MPI_Graph_map( (MPI_Comm) the_real_graphcomm, v2, v3, v4, v5 ));
    }
    void Get_topo( int * v2 )
    {
        MPIX_CALL( MPI_Topo_test( (MPI_Comm) the_real_graphcomm, v2 ));
    }
    void Get_neighbors( int v2, int v3, int * v4 )
    {
        MPIX_CALL( MPI_Graph_neighbors( (MPI_Comm) the_real_graphcomm, v2, v3, v4 ));
    }
    int Get_neighbors_count( int v2 )
    {
        int v3;
        MPIX_CALL( MPI_Graph_neighbors_count( (MPI_Comm) the_real_graphcomm, v2, &v3 ));
        return v3;
    }
    void Get_dims( int * v2, int * v3 )
    {
        MPIX_CALL( MPI_Graphdims_get( (MPI_Comm) the_real_graphcomm, v2, v3 ));
    }
};
class Cartcomm : public Intracomm {
		
  protected:
    MPI_Comm the_real_cartcomm;

  public:
    // new/delete
    inline Cartcomm(MPI_Comm obj) { the_real_cartcomm = obj; }
    inline Cartcomm(void) {the_real_cartcomm = MPI_COMM_NULL;}

    virtual ~Cartcomm() {}
    // copy/assignment
    Cartcomm :: Cartcomm(const Cartcomm &obj) {
      the_real_cartcomm = obj.the_real_cartcomm; }
    Cartcomm& Cartcomm::operator=(const Cartcomm &obj) {
      the_real_cartcomm = obj.the_real_cartcomm; return *this; }
    // logical
    bool operator== (const Cartcomm &obj) {
      return (the_real_cartcomm == obj.the_real_cartcomm); }
    bool operator!= (const Cartcomm &obj) {
      return (the_real_cartcomm != obj.the_real_cartcomm); }
    // C/C++ cast and assignment
    inline operator MPI_Comm*() { return &the_real_cartcomm; }
    inline operator MPI_Comm() { return the_real_cartcomm; }
    Cartcomm& Cartcomm::operator=(const MPI_Comm& obj) {
      the_real_cartcomm = obj; return *this; }
    int Get_cart_rank( int * v3 )
    {
        int v2;
        MPIX_CALL( MPI_Cart_rank( (MPI_Comm) the_real_cartcomm, &v2, v3 ));
        return v2;
    }
    void Map( int v2, int * v3, int * v4, int * v5 )
    {
        MPIX_CALL( MPI_Cart_map( (MPI_Comm) the_real_cartcomm, v2, v3, v4, v5 ));
    }
    int Shift( int v2, int v3, int * v5 )
    {
        int v4;
        MPIX_CALL( MPI_Cart_shift( (MPI_Comm) the_real_cartcomm, v2, v3, &v4, v5 ));
        return v4;
    }
    int Get_topo( void )
    {
        int v2;
        MPIX_CALL( MPI_Topo_test( (MPI_Comm) the_real_cartcomm, &v2 ));
        return v2;
    }
    Comm Sub( int * v2 )
    {
        Comm *v3 = new Comm;
        MPIX_CALL( MPI_Cart_sub( (MPI_Comm) the_real_cartcomm, v2, &(v3->the_real_comm) ));
        return *v3;
    }
    int Get_dim( void )
    {
        int v2;
        MPIX_CALL( MPI_Cartdim_get( (MPI_Comm) the_real_cartcomm, &v2 ));
        return v2;
    }
    Comm Dup( void )
    {
        Comm *v2 = new Comm;
        MPIX_CALL( MPI_Comm_dup( (MPI_Comm) the_real_cartcomm, &(v2->the_real_comm) ));
        return *v2;
    }
};
extern Datatype MPI::CHAR;
extern Datatype MPI::UNSIGNED_CHAR;
extern Datatype MPI::BYTE;
extern Datatype MPI::SHORT;
extern Datatype MPI::UNSIGNED_SHORT;
extern Datatype MPI::INT;
extern Datatype MPI::UNSIGNED;
extern Datatype MPI::LONG;
extern Datatype MPI::UNSIGNED_LONG;
extern Datatype MPI::FLOAT;
extern Datatype MPI::DOUBLE;
extern Datatype MPI::LONG_DOUBLE;
extern Datatype MPI::LONG_LONG_INT;
extern Datatype MPI::LONG_LONG;
extern Datatype MPI::PACKED;
extern Datatype MPI::LB;
extern Datatype MPI::UB;
extern Datatype MPI::FLOAT_INT;
extern Datatype MPI::DOUBLE_INT;
extern Datatype MPI::LONG_INT;
extern Datatype MPI::SHORT_INT;
extern Datatype MPI::LONG_DOUBLE_INT;
extern Datatype MPI::TWOINT;
extern const Op MPI::MAX;
extern const Op MPI::MIN;
extern const Op MPI::SUM;
extern const Op MPI::PROD;
extern const Op MPI::LAND;
extern const Op MPI::BAND;
extern const Op MPI::LOR;
extern const Op MPI::BOR;
extern const Op MPI::LXOR;
extern const Op MPI::BXOR;
extern const Op MPI::MINLOC;
extern const Op MPI::MAXLOC;
extern const Op MPI::REPLACE;
extern Intracomm MPI::COMM_WORLD;
extern Intracomm MPI::COMM_SELF;
extern const Comm MPI::COMM_NULL;
extern const Group MPI::GROUP_EMPTY;
extern void Init(void);
extern void Finalize(void);
} // namespace MPI
